; ASCII table/codepage utility v1.0.0 by Mark Jones 2005

.386
.MODEL flat, stdcall

option casemap:none

include windows.inc
include kernel32.inc
include user32.inc
include masm32.inc
include shlwapi.inc
include c:\masm32\macros\macros.asm

includelib kernel32.lib
includelib user32.lib
includelib masm32.lib
includelib shlwapi.lib

Main    proto

.data
hWnd    DD  0
szCPs   DB  13,10
        DB  "                      Character                         Character",13,10
        DB  "      Country           Sets            Country           Sets   ",13,10
        DB  "===================  ==========   ===================  ==========",13,10
        DB  "Albania               852, 850    Arabia                850, 864 ",13,10
        DB  "Argentina             850, 437    Australia             437, 850 ",13,10
        DB  "Austria               850, 437    Belgium               850, 437 ",13,10
        DB  "Bosnia/Herzegovina    852, 850    Brazil                850, 437 ",13,10
        DB  "Bulgaria              855, 850    Canada French         850, 863 ",13,10
        DB  "Canada English        850, 863    Chile                 850, 437 ",13,10
        DB  "Colombia              850, 437    Croatia               852, 850 ",13,10
        DB  "Czech Republic        852, 850    Denmark               850, 865 ",13,10
        DB  "Ecuador               850, 437    Finland               850, 437 ",13,10
        DB  "France                850, 437    Germany               850, 437 ",13,10
        DB  "Greece           869, 737, 850    Hong Kong             437, **  ",13,10
        DB  "Hungary               852, 850    Iceland               850, 861 ",13,10
        DB  "India                 437, **     International English 437, 850 ",13,10
        DB  "Ireland               850, 437    Israel                850, 862*",13,10
        DB  "Italy                 850, 437    Japan                 437, 932*",13,10
        DB  "Korea                 437, 934*   Latin America         850, 437 ",13,10
        DB  "Macedonia             855, 850    Malaysia              437, **  ",13,10
        DB  "Mexico                850, 437    Netherlands           850, 437 ",13,10
        DB  "New Zealand           437, 850    Norway                850, 865 ",13,10
        DB  "China                 437, 936*   Poland                852, 850 ",13,10
        DB  "Portugal              850, 860    Romania               852, 850 ",13,10
        DB  "Russia     866/855/852/850/437    Serbia/Montenegro     855, 850 ",13,10
        DB  "Singapore             437, **     Slovakia              852, 850 ",13,10
        DB  "Slovenia              852, 850    South Africa          437, 850 ",13,10
        DB  "Spain                 850, 437    Sweden                850, 437 ",13,10
        DB  "Switzerland           850, 437    Taiwan                437, 938*",13,10
        DB  "Turkey                857, 850    United Kingdom        850, 437 ",13,10
        DB  "United States         437, 850    Venezuela             850, 437 ",13,10
        DB  "Yugoslavia            852, 850    Yugoslavia Cyrillic   855, 850 ",13,10,13,10
        DB  "> Enter a codepage: ",00  

szTable DB 13,10
        DB  "Dec Hx Oct Chr   Dec Hx Oct Chr   Dec Hx Oct Chr   Dec Hx Oct Chr",13,10 
        DB  "-----------------------------------------------------------------",13,10 
        DB  " 0  00  0  NUL    64 40 100  ",64,"    128 80 200  ",128,"    192 C0 300  ",192," ",13,10 
        DB  " 1  01  1   ",01,"     65 41 101  ",65,"    129 81 201  ",129,"    193 C1 301  ",193," ",13,10 
        DB  " 2  02  2   ",02,"     66 42 102  ",66,"    130 82 202  ",130,"    194 C2 302  ",194," ",13,10 
        DB  " 3  03  3   ",03,"     67 43 103  ",67,"    131 83 203  ",131,"    195 C3 303  ",195," ",13,10 
        DB  " 4  04  4   ",04,"     68 44 104  ",68,"    132 84 204  ",132,"    196 C4 304  ",196," ",13,10 
        DB  " 5  05  5   ",05,"     69 45 105  ",69,"    133 85 205  ",133,"    197 C5 305  ",197," ",13,10 
        DB  " 6  06  6   ",06,"     70 46 106  ",70,"    134 86 206  ",134,"    198 C6 306  ",198," ",13,10 
        DB  " 7  07  7  BEL    71 47 107  ",71,"    135 87 207  ",135,"    199 C7 307  ",199," ",13,10 
        DB  " 8  08  10 BS     72 48 110  ",72,"    136 88 210  ",136,"    200 C8 310  ",200," ",13,10 
        DB  " 9  09  11 TAB    73 49 111  ",73,"    137 89 211  ",137,"    201 C9 311  ",201," ",13,10 
        DB  " 10 0A  12 LF     74 4A 112  ",74,"    138 8A 212  ",138,"    202 CA 312  ",202," ",13,10 
        DB  " 11 0B  13  ",11,"     75 4B 113  ",75,"    139 8B 213  ",139,"    203 CB 313  ",203," ",13,10 
        DB  " 12 0C  14  ",12,"     76 4C 114  ",76,"    140 8C 214  ",140,"    204 CC 314  ",204," ",13,10 
        DB  " 13 0D  15 CR     77 4D 115  ",77,"    141 8D 215  ",141,"    205 CD 315  ",205," ",13,10 
        DB  " 14 0E  16  ",14,"     78 4E 116  ",78,"    142 8E 216  ",142,"    206 CE 316  ",206," ",13,10 
        DB  " 15 0F  17  ",15,"     79 4F 117  ",79,"    143 8F 217  ",143,"    207 CF 317  ",207," ",13,10 
        DB  " 16 10  20  ",16,"     80 50 120  ",80,"    144 90 220  ",144,"    208 D0 320  ",208," ",13,10 
        DB  " 17 11  21  ",17,"     81 51 121  ",81,"    145 91 221  ",145,"    209 D1 321  ",209," ",13,10 
        DB  " 18 12  22  ",18,"     82 52 122  ",82,"    146 92 222  ",146,"    210 D2 322  ",210," ",13,10 
        DB  " 19 13  23  ",19,"     83 53 123  ",83,"    147 93 223  ",147,"    211 D3 323  ",211," ",13,10 
        DB  " 20 14  24  ",20,"     84 54 124  ",84,"    148 94 224  ",148,"    212 D4 324  ",212," ",13,10 
        DB  " 21 15  25  ",21,"     85 55 125  ",85,"    149 95 225  ",149,"    213 D5 325  ",213," ",13,10 
        DB  " 22 16  26  ",22,"     86 56 126  ",86,"    150 96 226  ",150,"    214 D6 326  ",214," ",13,10 
        DB  " 23 17  27  ",23,"     87 57 127  ",87,"    151 97 227  ",151,"    215 D7 327  ",215," ",13,10 
        DB  " 24 18  30  ",24,"     88 58 130  ",88,"    152 98 230  ",152,"    216 D8 330  ",216," ",13,10 
        DB  " 25 19  31  ",25,"     89 59 131  ",89,"    153 99 231  ",153,"    217 D9 331  ",217," ",13,10 
        DB  " 26 1A  32  ",26,"     90 5A 132  ",90,"    154 9A 232  ",154,"    218 DA 332  ",218," ",13,10 
        DB  " 27 1B  33  ",27,"     91 5B 133  ",91,"    155 9B 233  ",155,"    219 DB 333  ",219," ",13,10 
        DB  " 28 1C  34  ",28,"     92 5C 134  ",92,"    156 9C 234  ",156,"    220 DC 334  ",220," ",13,10 
        DB  " 29 1D  35  ",29,"     93 5D 135  ",93,"    157 9D 235  ",157,"    221 DD 335  ",221," ",13,10 
        DB  " 30 1E  36  ",30,"     94 5E 136  ",94,"    158 9E 236  ",158,"    222 DE 336  ",222," ",13,10 
        DB  " 31 1F  37  ",31,"     95 5F 137  ",95,"    159 9F 237  ",159,"    223 DF 337  ",223," ",13,10 
        DB  " 32 20  40  ",32,"     96 60 140  ",96,"    160 A0 240  ",160,"    224 E0 340  ",224," ",13,10 
        DB  " 33 21  41  ",33,"     97 61 141  ",97,"    161 A1 241  ",161,"    225 E1 341  ",225," ",13,10 
        DB  " 34 22  42  ",34,"     98 62 142  ",98,"    162 A2 242  ",162,"    226 E2 342  ",226," ",13,10 
        DB  " 35 23  43  ",35,"     99 63 143  ",99,"    163 A3 243  ",163,"    227 E3 343  ",227," ",13,10  
        DB  " 36 24  44  ",36,"    100 64 144  ",100,"    164 A4 244  ",164,"    228 E4 344  ",228," ",13,10 
        DB  " 37 25  45  ",37,"    101 65 145  ",101,"    165 A5 245  ",165,"    229 E5 345  ",229," ",13,10 
        DB  " 38 26  46  ",38,"    102 66 146  ",102,"    166 A6 246  ",166,"    230 E6 346  ",230," ",13,10 
        DB  " 39 27  47  ",39,"    103 67 147  ",103,"    167 A7 247  ",167,"    231 E7 347  ",231," ",13,10 
        DB  " 40 28  50  ",40,"    104 68 150  ",104,"    168 A8 250  ",168,"    232 E8 350  ",232," ",13,10 
        DB  " 41 29  51  ",41,"    105 69 151  ",105,"    169 A9 251  ",169,"    233 E9 351  ",233," ",13,10 
        DB  " 42 2A  52  ",42,"    106 6A 152  ",106,"    170 AA 252  ",170,"    234 EA 352  ",234," ",13,10 
        DB  " 43 2B  53  ",43,"    107 6B 153  ",107,"    171 AB 253  ",171,"    235 EB 353  ",235," ",13,10 
        DB  " 44 2C  54  ",44,"    108 6C 154  ",108,"    172 AC 254  ",172,"    236 EC 354  ",236," ",13,10 
        DB  " 45 2D  55  ",45,"    109 6D 155  ",109,"    173 AD 255  ",173,"    237 ED 355  ",237," ",13,10 
        DB  " 46 2E  56  ",46,"    110 6E 156  ",110,"    174 AE 256  ",174,"    238 EE 356  ",238," ",13,10 
        DB  " 47 2F  57  ",47,"    111 6F 157  ",111,"    175 AF 257  ",175,"    239 EF 357  ",239," ",13,10 
        DB  " 48 30  60  ",48,"    112 70 160  ",112,"    176 B0 260  ",176,"    240 F0 360  ",240," ",13,10 
        DB  " 49 31  61  ",49,"    113 71 161  ",113,"    177 B1 261  ",177,"    241 F1 361  ",241," ",13,10 
        DB  " 50 32  62  ",50,"    114 72 162  ",114,"    178 B2 262  ",178,"    242 F2 362  ",242," ",13,10 
        DB  " 51 33  63  ",51,"    115 73 163  ",115,"    179 B3 263  ",179,"    243 F3 363  ",243," ",13,10 
        DB  " 52 34  64  ",52,"    116 74 164  ",116,"    180 B4 264  ",180,"    244 F4 364  ",244," ",13,10 
        DB  " 53 35  65  ",53,"    117 75 165  ",117,"    181 B5 265  ",181,"    245 F5 365  ",245," ",13,10 
        DB  " 54 36  66  ",54,"    118 76 166  ",118,"    182 B6 266  ",182,"    246 F6 366  ",246," ",13,10 
        DB  " 55 37  67  ",55,"    119 77 167  ",119,"    183 B7 267  ",183,"    247 F7 367  ",247," ",13,10 
        DB  " 56 38  70  ",56,"    120 78 170  ",120,"    184 B8 270  ",184,"    248 F8 370  ",248," ",13,10 
        DB  " 57 39  71  ",57,"    121 79 171  ",121,"    185 B9 271  ",185,"    249 F9 371  ",249," ",13,10 
        DB  " 58 3A  72  ",58,"    122 7A 172  ",122,"    186 BA 272  ",186,"    250 FA 372  ",250," ",13,10 
        DB  " 59 3B  73  ",59,"    123 7B 173  ",123,"    187 BB 273  ",187,"    251 FB 373  ",251," ",13,10 
        DB  " 60 3C  74  ",60,"    124 7C 174  ",124,"    188 BC 274  ",188,"    252 FC 374  ",252," ",13,10 
        DB  " 61 3D  75  ",61,"    125 7D 175  ",125,"    189 BD 275  ",189,"    253 FD 375  ",253," ",13,10 
        DB  " 62 3E  76  ",62,"    126 7E 176  ",126,"    190 BE 276  ",190,"    254 FE 376  ",254," ",13,10 
        DB  " 63 3F  77  ",63,"    127 7F 177  ",127,"    191 BF 277  ",191,"    255 FF 377  ",255," ",13,10,13,10
        DB  "> Display another codepage? (y/n): ",00

.code
Start:
    invoke GetModuleHandle,eax
    mov hWnd,eax
    invoke Main
    invoke ExitProcess,0


Main proc
    print chr$(" ASCII table/codepage utility by Mark Jones (gzscuqn02ATsneakemailD0Tcom)",13,10)
    invoke Sleep,1750
nop    ; for debugging
    invoke ShowWindow,hWnd,WS_MAXIMIZE   ; does not work, INVALID_HWND

doagain:
    print addr szCPs                ; print the codepages and prompt

invalidCP:
    mov eax, input()                ; get a string value
    invoke StrToInt,eax             ; convert string to integer
    invoke SetConsoleOutputCP,eax   ; try to set it as the codepage
    cmp eax,0                       ; if error,
    jz invalidCP                    ; ask again

    print addr szTable              ; print the table and prompt

invalidYN:
    mov eax, input()                ; get Y or N
    mov edx, [eax]                  ; single byte in dl
    cmp dl, "y"
    jz doagain
    cmp dl, "Y"
    jz doagain
    cmp dl, "n"
    jz endit
    cmp dl, "N"
    jz endit
    jmp invalidYN                   ; none of the above, ask again

endit:    
	ret
Main EndP

end Start